#pragma once
#include <vector>

#include "fps_class.h"
#include "object.h"

class stats
{
public:

    stats();
    ~stats();

    bool initialize(fps_class* fps, application_class* app);
    void update_stats();
    void update();

    int get_total_vertex_count() const;
    int get_total_triangle_count() const;
    int get_visible_triangle_count() const;

    int get_current_fps() const { return current_fps_; };
    int get_min_fps() const { return min_fps_; };
    int get_max_fps() const { return max_fps_; };
    float get_frame_time() const { return current_frame_time_;};
    int get_draw_calls() const { return drawcalls_; };
    
    void increment_draw_call_count() { drawcalls_++; };
    void reset_draw_call_count() { drawcalls_ = 0; };

private:
    fps_class* fps_;
    int drawcalls_;
    application_class* app_;

    std::vector<object*> object_vec_;
    std::vector<object*> cubes_vec_;
    std::vector<object*> terrain_chunk_vec_;

    int total_vertex_count_;
    int total_triangle_count_;
    int visible_triangle_count_ = 0;
    int current_fps_ = 0;
    int min_fps_ = 0;
    int max_fps_ = 0;
    float current_frame_time_ = 0.0f;
    
};
